CREATE OR REPLACE TRIGGER LOG_CMP_FILIALROTA
AFTER INSERT OR UPDATE OR DELETE
ON FILIALROTA FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1500);
  V_CDFILLOGOPER VARCHAR2(4);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_IDPARAM      VARCHAR2(1);


BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF UPDATING THEN
      IF (NVL(:OLD.CDROTATRANS, 0) <> NVL(:NEW.CDROTATRANS, 0)) THEN
         V_DESC := V_DESC ||'Cd. Rota:' ||''|| NVL(:NEW.CDROTATRANS,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDFILIAL, 0) <> NVL(:NEW.CDFILIAL, 0)) THEN
         V_DESC := V_DESC ||'Filial:' ||''|| NVL(:NEW.CDFILIAL,'') ||'   ';
      END IF;
      IF (NVL(:OLD.CDFILIROTA, 0) <> NVL(:NEW.CDFILIROTA, 0)) THEN
         V_DESC := V_DESC ||'Filial Rota:' ||''|| NVL(:NEW.CDFILIROTA,'') ||'   ';
      END IF;
      IF (NVL(:OLD.NRORDFILROTA, 0) <> NVL(:NEW.NRORDFILROTA, 0)) THEN
         V_DESC := V_DESC ||'N. Ordem:' ||''|| NVL(:NEW.NRORDFILROTA,'') ||'   ';
      END IF;
      IF (NVL(:OLD.IDROTAPRINCFILI, 0) <> NVL(:NEW.IDROTAPRINCFILI, 0)) THEN
         V_DESC := V_DESC ||'Rota Princ.:' ||''|| NVL(:NEW.IDROTAPRINCFILI,'') ||'   ';
      END IF;
      V_ITPESQ       := :NEW.CDROTATRANS|| :NEW.CDFILIAL|| :NEW.CDFILIROTA;
      V_CDFILLOGOPER := :NEW.CDFILIAL;
      V_IDTIPOOPER   := '2';
   ELSE
      IF INSERTING THEN
         V_DESC   :=        'Cd. Rota:'     ||''  || NVL(:NEW.CDROTATRANS,'')      ||'  '  ||
                            'Filial:'        ||''  || NVL(:NEW.CDFILIAL,'')         ||'  '  ||
                            'Filial Rota:'   ||''  || NVL(:NEW.CDFILIROTA,'')       ||'  '  ||
                            'N. Ordem:'     ||''  || NVL(:NEW.NRORDFILROTA,'')     ||'  '  ||
                            'Rota Princ.:'   ||''  || NVL(:NEW.IDROTAPRINCFILI,'');

         V_ITPESQ       := :NEW.CDROTATRANS|| :NEW.CDFILIAL|| :NEW.CDFILIROTA;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
         V_IDTIPOOPER   := '1';
      ELSE
         IF DELETING THEN
            V_DESC  :=      'Cd. Rota:'     ||''  || NVL(:OLD.CDROTATRANS,'')      ||'  '  ||
                            'Filial:'        ||''  || NVL(:OLD.CDFILIAL,'')         ||'  '  ||
                            'Filial Rota:'   ||''  || NVL(:OLD.CDFILIROTA,'')       ||'  '  ||
                            'N. Ordem:'     ||''  || NVL(:OLD.NRORDFILROTA,'')     ||'  '  ||
                            'Rota Princ.:'   ||''  || NVL(:OLD.IDROTAPRINCFILI,'');

            V_ITPESQ       := :OLD.CDROTATRANS|| :OLD.CDFILIAL|| :OLD.CDFILIROTA;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
            V_IDTIPOOPER     := '3';
         END IF;
      END IF;
   END IF;
   IF (V_DESC IS NOT NULL)   THEN
      V_DESC := SUBSTR(V_DESC, 1, 300);
      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER,
          CDFILLOGOPER)
      VALUES
         ('FILIALROTA',
          SYSDATE,
          NVL(V_NMOPERADOR,' '),
          V_IDTIPOOPER,
          V_DESC,
          V_ITPESQ,
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER,
          V_CDFILLOGOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CMP_FILIALROTA','5.50.xxx'); END;
/
