<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


class Element extends \Doctrine\ORM\EntityRepository {
    
    public function getElementsByProfile($organizationId, $profileId){

		$query = <<<SQL
			SELECT E.ID, E.PARENT, NVL(E.LABEL, E.NAME) AS LABEL, E.ELEMENT_TYPE,
                   RP.RULE_TYPE AS RULE, RP.ID AS RULE_ID
              FROM ELEMENT E,
                   (SELECT R.ELEMENT, R.RULE_TYPE, R.ID
                      FROM RULE R, PROFILE P
                     WHERE P.ID = R.PROFILE
                       AND P.ID = :profileId) RP
             WHERE E.ID = RP.ELEMENT(+)
             ORDER BY DECODE(E.ELEMENT_TYPE, 'G', 1, 'M', 2, 'C', 3, 'W', 4, 'F', 5, 'A', 6, 7), NVL(E.LABEL, E.NAME)
SQL;
		$param = array(
			'organizationId' => $organizationId,
			'profileId' => $profileId
		);
		return $this->getEntityManager()->getConnection()->fetchAll($query, $param);

	}

	public function removeElementsNotIn($elementIds){
		$query = <<<SQL
			DELETE FROM ELEMENT WHERE ID NOT IN ($elementIds)
SQL;
		$param = array(
			'elementIds' => $elementIds 
		);

		return $this->getEntityManager()->getConnection()->executeUpdate($query, $param);
	}
}